package org.keti.pscm;

//배열을 조작하기 위한 메서드를 제공하는 클래스
import java.util.Arrays;
import org.springframework.context.ApplicationContext;


import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
@Configuration
@ComponentScan
@EnableAutoConfiguration
@Controller
@SpringBootApplication
public class Application_CMS {


	public static void main(String[] args) {
        //SpringApplication.run(StartJspApplication.class, args);
		SpringApplication.run(Application_CMS.class, args);
		/*
         DaoFactory가 UserDAO를 비롯한 DAO 오브젝트를 생성하고 DB커넥션 객체와 관계를 맺어주는 제한적인 역할
         ApplicationContext는 어플리케이션에서 IoC를 적용해서 관리할 모든 오브젝트에 대한 생성과 관계설정을 담당
         @Bean
         */
		/*
		 * Inversion of Control
		  은 프레임워크가 정의한 추상(interface 또는 abstract class)을 클라이언트 코드가 구현을 하고, 구현된 객체를 프레임워크에 전달(또는 주입) , 프레임워크가 제어를 가지게 함으로써 클라이언트 코드로 부터 제어의 수를 줄이게 하는 것
		 모든 제어를 클라이언트 코드가 가지고 있는 구조적 설계와 비교해 프레임워크가 제어를 가지는 것을 제어가 역전 되었다 라고 말합니다.
		
		 의존 그래프의 생성과 주입 전략을 가진 객체가 등장 했으니 이것을 경량 컨테이너 라고 하는 놈 입니다. 제어를 넘겨 받은 컨테이너
		 * */
		
		//오브젝트 생성을 책임지는 오브젝트 팩토리(DaoFactory)에 대응하는 것이 ApplicationContext이다.
		//Spring에선 이 ApplicationContext를 IoC컨테이너라 하기도 하고, Spring컨테이너,BeanFactory 부르기도 한다
    	//ApplicationContext ctx = SpringApplication.run(Application.class, args);
    	
    	//   SpringApplication class provides a convenient way to bootstrap a Spring application that will be started from a main() method.  	
    	//String[] beanNames =ctx.getBeanDefinitionNames();
    	//Arrays.sort(beanNames);
    	//Arrays.sort: 한글 문자 가나다순으로, 숫자를 크기 순으로 정렬(Sorting)
/*    	for(String beanName : beanNames){
    		System.out.println(beanNames);
    	}*/
    			
    }
	
	
	/* @RequestMapping("/")
	    @ResponseBody
	    String home() {
	        return "Hello World!";
	    }*/
    
}
